Public Class TransportStreamInfo
    Public Sub New()
        Me.m_pids = New ArrayList
    End Sub

    Public SID As Integer
    Public PMT As Integer

    'Auflistung der PID's
    Private m_pids As ArrayList

    Public Sub AddPID(ByVal Type As PIDType, ByVal Value As Integer)
        m_pids.Add(New PID(Type, Value))
    End Sub

    Public Function VideoPIDs() As Integer()
        Return getPids(PIDType.Video)
    End Function

    Public Function AudioPIDs() As Integer()
        Return getPids(PIDType.Audio)
    End Function

    Public Function TeletextPIDs() As Integer()
        Return getPids(PIDType.Teletext)
    End Function

    Public Function SubpicturePIDs() As Integer()
        Return getPids(PIDType.Subpicture)
    End Function


    Private Function GetPIDs(ByVal PIDType As PIDType) As Integer()
        Dim PIDs As New ArrayList

        For Each PID As PID In m_pids
            If PID.Type = PIDType Then PIDs.Add(PID.Value)
        Next
        Return PIDs.ToArray(GetType(Integer))
    End Function


    Private Structure PID
        Public Sub New(ByVal Type As PIDType, ByVal Value As Integer)
            Me.Type = Type
            Me.Value = Value
        End Sub

        Public Type As PIDType
        Public Value As Integer
    End Structure
End Class

Public Enum PIDType
    Audio
    Video
    Subpicture
    Teletext
End Enum


