' @(#)VIDEO.java - some video constants
'
' Copyright (c) 2003,2004 by dvb.matt, All Rights Reserved. 
' 
' This file is part of X, a free Java based demux utility.
' X is intended for educational purposes only, as a non-commercial test project.
' It may not be used otherwise. Most parts are only experimental.
'  
'
' This program is free software; you can redistribute it free of charge
' and/or modify it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Public Enum VideoFormatType
    MPEG1
    MPEG2
End Enum

Public Structure VideoInfo
    Public Format As VideoFormatType
    Public FormatText As String
    Public Width As Integer
    Public Height As Integer
    Public FPS As String
    Public AspectRatio As String
    Public Bitrate As Integer 'in kbps
    Public vbv As Integer

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1}x{2}, {3}, {4}, {5:#,##0}kbps, {6}vbv", Me.FormatText, Me.Width, Me.Height, Me.FPS, Me.AspectRatio, Me.Bitrate, Me.vbv)
    End Function
End Structure


Friend Class VideoBuffer
    Private ReadOnly m_aspectratio_string() As String = {"res.", "1:1", "4:3", "16:9", "2.21:1", "0.8055", "0.8437", "0.9375", "0.9815", "1.0255", "1.0695", "1.1250", "1.1575", "1.2015", "res.", "res."}
    Private ReadOnly m_fps_string() As String = {"forbidden fps", "23.976fps", "24fps", "25fps", "29.97fps", "30fps", "50fps", "59.94fps", "60fps", "n.def.", "n.def.", "n.def.", "n.def.", "n.def.", "n.def.", "n.def."}

    Friend Function GetVideoInfo(ByVal Gop As Byte(), ByVal VideoFormat As VideoFormatType) As VideoInfo
        Dim VideoInfo As VideoInfo
        VideoInfo.Format = VideoFormat

        With VideoInfo
            .FormatText = IIf(.Format = VideoFormatType.MPEG1, "MPEG-1", "MPEG-2")
            .Width = ((255 And Gop(4)) << 4 Or Bitweise.RechtsOhne((240 And Gop(5)), 4))
            .Height = ((15 And Gop(5)) << 8 Or (255 And Gop(6)))
            .FPS = m_fps_string(15 And Gop(7))
            .AspectRatio = m_aspectratio_string(Bitweise.RechtsOhne((255 And Gop(7)), 4))
            .Bitrate = (((255 And Gop(8)) << 10 Or (255 And Gop(9)) << 2 Or Bitweise.RechtsOhne((192 And Gop(10)), 6)) * 400) / 1000
            .vbv = ((31 And Gop(10)) << 5 Or Bitweise.RechtsOhne((248 And Gop(11)), 3))
        End With

        Return VideoInfo
    End Function

End Class